Index: mono-1.2.4/configure.in
===================================================================
--- mono-1.2.4.orig/configure.in
+++ mono-1.2.4/configure.in
@@ -1881,18 +1881,14 @@ if test "x$with_tls" = "x__thread"; then
 fi
 
 if test ${TARGET} = ARM; then
-	dnl ******************************************
-	dnl *** Check to see what FPU is available ***
-	dnl ******************************************
-	AC_MSG_CHECKING(which FPU to use)
+	dnl *******************************************************
+	dnl *** Check to see what floating point format is used ***
+	dnl *******************************************************
+	AC_MSG_CHECKING(which floating point format to use)
 
 	AC_TRY_COMPILE([], [
 		__asm__ ("ldfd f0, [r0]");
-		], fpu=FPA, [
-			AC_TRY_COMPILE([], [
-				__asm__ ("fldd d0, [r0]");
-			], fpu=VFP, fpu=NONE)
-		])
+		], fpu=FPA, fpu=VFP)
 
 	AC_MSG_RESULT($fpu)
 	CPPFLAGS="$CPPFLAGS -DARM_FPU_$fpu=1"
Index: mono-1.2.4/libgc/configure
===================================================================
--- mono-1.2.4.orig/libgc/configure
+++ mono-1.2.4/libgc/configure
@@ -4569,7 +4569,7 @@ case "$THREADS" in
     THREADS=posix
     THREADDLLIBS=-lpthread
     case "$host" in
-     x86-*-linux* | ia64-*-linux* | i386-*-linux* | i486-*-linux* | i586-*-linux* | i686-*-linux* | x86_64-*-linux* | alpha*-*-linux* | s390*-*-linux* | sparc*-*-linux* | powerpc-*-linux*)
+     x86-*-linux* | ia64-*-linux* | i386-*-linux* | i486-*-linux* | i586-*-linux* | i686-*-linux* | x86_64-*-linux* | alpha*-*-linux* | arm*-*-linux* | s390*-*-linux* | sparc*-*-linux* | powerpc-*-linux*)
 	cat >>confdefs.h <<\_ACEOF
 #define GC_LINUX_THREADS 1
 _ACEOF
Index: mono-1.2.4/libgc/configure.in
===================================================================
--- mono-1.2.4.orig/libgc/configure.in
+++ mono-1.2.4/libgc/configure.in
@@ -77,7 +77,7 @@ case "$THREADS" in
     THREADS=posix
     THREADDLLIBS=-lpthread
     case "$host" in
-     x86-*-linux* | ia64-*-linux* | i386-*-linux* | i486-*-linux* | i586-*-linux* | i686-*-linux* | x86_64-*-linux* | alpha*-*-linux* | s390*-*-linux* | sparc*-*-linux* | powerpc-*-linux*)
+     x86-*-linux* | ia64-*-linux* | i386-*-linux* | i486-*-linux* | i586-*-linux* | i686-*-linux* | x86_64-*-linux* | alpha*-*-linux* | arm*-*-linux* | s390*-*-linux* | sparc*-*-linux* | powerpc-*-linux*)
 	AC_DEFINE(GC_LINUX_THREADS)
 	AC_DEFINE(_REENTRANT)
         if test "${enable_parallel_mark}" = yes; then
Index: mono-1.2.4/mono/arch/arm/tramp.c
===================================================================
--- mono-1.2.4.orig/mono/arch/arm/tramp.c
+++ mono-1.2.4/mono/arch/arm/tramp.c
@@ -10,6 +10,9 @@
 
 #if defined(_WIN32_WCE) || defined (UNDER_CE)
 #	include <windows.h>
+#else
+#include <unistd.h>
+#include <sys/mman.h>
 #endif
 
 #include <errno.h>
@@ -75,8 +78,6 @@ void* alloc_code_buff (int num_instr)
 	code_buff = malloc(code_size);
 	VirtualProtect(code_buff, code_size, PAGE_EXECUTE_READWRITE, &old_prot);
 #else
-#include <unistd.h>
-#include <sys/mman.h>
 	int page_size = sysconf(_SC_PAGESIZE);
 	int new_code_size;
 
